# Implementational of a rational number library that uses
# lists of size 2 as their representation.

def GCD(a,b):
    """ Computes and returns the greatest common divisor. """ 
    if a < b:
        a,b = b,a
    if b < 0:
        b *= -1
    while b > 0:
        a,b = b,a%b
    return a

def createRational(n,d):
    assert(d != 0)
    if d < 0:
        n *= -1
        d *= -1
    g = GCD(n,d)
    return [n//g, d//g]

def numerator(r):
    return r[0]

def denominator(r):
    return r[1]

def equalRational(r,s):
    nr = numerator(r)
    dr = denominator(r)
    ns = numerator(s)
    ds = denominator(s)
    return (nr*ds == ns*dr)

def sumRational(r,s):
    nr = numerator(r)
    dr = denominator(r)
    ns = numerator(s)
    ds = denominator(s)
    return createRational(nr*ds+dr*ns, dr*ds)

def productRational(r,s):
    nr = numerator(r)
    dr = denominator(r)
    ns = numerator(s)
    ds = denominator(s)
    return createRational(nr*ns, dr*ds)

def stringOfRational(r):
    nr = numerator(r)
    dr = denominator(r)
    if dr == 1:
        return f"{nr}"
    else:
        return f"{nr}/{dr}"

def outputRational(r):
    print(stringOfRational(r))



                        
